
import bench_test
import operator 
import petri

class Example(object):

  def __init__(self, x):
    self.name = x[0]
    deltas = map(Example._CreateDelta, *x[1:3])
    tmins = [petri.Marking(t) for t in x[2]]
    self.transition = petri.GetUniformTransition(deltas, tmins)
    self.initial = petri.Marking(x[3])
    if x[4] == None:
      self.expected = None
    else:
     self.expected = set(map(tuple,x[4]))
  
  @staticmethod
  def _CreateDelta(tmin, tmax):
      return map(operator.sub, tmin, tmax)
    
  def __repr__(self):
    return 'Example [%s]' % self.name

def BuildExamples():
  examples = []
  
  def Examples(*x):
    examples.append(_TransformExample(x))
  
  bench_test.Sample = Examples
  bench_test.Init()
  return examples

def _TransformExample(x):
  return Example(x)
